package de.hsbo.fbv.bmg.graphs;

/**
 * Klassedeklaration fr gerichtete (ungewichtete) Kanten.<br>
 * Die Klasse unterscheidet sich von ihrer Elternklasse nur durch 
 * ergnzte und berschriebene Methoden.
 * @author zimmermann
 *
 */
public class DirectedEdge extends Edge {
	
	// keine zustzlichen Attribute

	/**
	 * Konstruktor
	 * @param o - Bezugsobjekt
	 * @param start - Startknoten
	 * @param end - Endknoten
	 */
	public DirectedEdge(Object o, Node start, Node end) {
		super(o, start, end);
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Gibt den Startknoten zurck.
	 * @return
	 */
	public Node getStartNode() {
		return nodes[0];
	}
	
	/**
	 * Gibt den Endknoten zurck.
	 * @return
	 */
	public Node getEndNode() {
		return nodes[1];
	}

	@Override
	public boolean hasNodes(Node start, Node end) {
		if(nodes[0]==start && nodes[1]==end)
			return true;
		else
			return false;
	}

	@Override
	public Node getNextNode(Node start) {
		if(nodes[0]==start)
			return nodes[1];
		else
			return null;
	}
	
	public Node getPrevNode(Node end) {
		if(nodes[1]==end)
			return nodes[0];
		else
			return null;
	}

	
	/**
	 * berschreibt die Methode von Klasse Edge. <br>
	 * Die Methode wird in dem Sinne ausgelegt, dass es mglich sein muss, von der 
	 * Kante this ber den Knoten zur Kante e zu gelangen.
	 */
	public Node getCommonNode(Edge e) {
		try {
			DirectedEdge de = (DirectedEdge)e;
			if(this.getEndNode()==de.getStartNode())
				return this.getEndNode();
			else
				return null;
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			return null;
		}
	}
	
	/**
	 * Erzeugt aus einer ungerichteten Kante zwei neue gerichtete Kanten.
	 * @param edge
	 * @return
	 */
	public static DirectedEdge[] getDirectedEdges(Edge edge) {
		if(edge instanceof DirectedEdge)
			return new DirectedEdge[] {(DirectedEdge)edge};
		else
			return new DirectedEdge[] {
				new DirectedEdge(edge.getObject(), edge.getNodes()[0], edge.getNodes()[1]),
				new DirectedEdge(edge.getObject(), edge.getNodes()[1], edge.getNodes()[0])};
	}

}
