package de.hsbo.fbv.bmg.graphs;
import java.util.Arrays;
import java.util.HashSet;

/**
 * Erster Ansatz fr die Klasse Graph<br>
 * Einfacher Graph, der nur Kanten (edges) speichert.
 * Die Knoten (nodes) werden nur bei den Kanten verwaltet.
 * @author A.Zimmermann, HS Bochum, 2011
 *
 */
public class Graph {
	// Attribute
	HashSet edges = new HashSet();
	
	/**
	 * Fgt dem Graphen eine neu Kante hinzu.
	 * @param edge
	 * @return
	 */
	public boolean add(Edge edge) {
		return edges.add(edge);
	}
	
	/**
	 * Entfernt die Kante aus dem Graphen.
	 * @param edge
	 * @return
	 */
	public boolean remove(Edge edge) {
		return edges.remove(edge);
	}
	
	/**
	 * Gibt die Anzahl der enthaltenen Kanten an.
	 * @return
	 */
	public int EdgeSize() {
		return edges.size();
	}
	
	/**
	 * Gibt die enthaltenen Kanten zurck.
	 * @return
	 */
	public Edge[] getEdges() {
		Edge[] edgeArray = new Edge[edges.size()];
		return (Edge[])edges.toArray(edgeArray);
	}
	
	/**
	 * Gibt die enthaltenen Knoten zurck.
	 * @return
	 */
	public Node[] getNodes() {
		HashSet nodes = new HashSet();
		Edge[] edgeArray = this.getEdges();
		for(int i=0; i<edgeArray.length; i++) {
			nodes.add(edgeArray[i].getNodes()[0]);
			nodes.add(edgeArray[i].getNodes()[1]);
		}
		Node[] nodeArray = new Node[nodes.size()];
		return (Node[])nodes.toArray(nodeArray);
	}
	
	@Override
	public String toString() {
		String s = "Graph [edges=" + edges + "],\n";
		s = s +    "      [nodes=" + Arrays.toString(getNodes()) +"]";
		return s;
	}
	
}	// Ende Klassendeklaration
