package de.hsbo.fbv.bmg.graphs;

/**
 * Klassendeklaration fr ungerichtete gewichtete Kanten.
 * @author A.Zimmermann, HS Bochum 2011
 *
 */
public class WeightedEdge extends Edge {
	
	// Attribute
	double weight;

	/**
	 * Konstruktor ohne Angabe des Kantengewichts. 
	 * Das Wert wird auf 1.0 festgesetzt.
	 * @param o
	 * @param n0
	 * @param n1
	 */
	public WeightedEdge(Object o, Node n0, Node n1) {
		super(o, n0, n1);
		this.weight = 1.0;
		// TODO Auto-generated constructor stub
	}

	/**
	 * Konstruktor mit Angabe des Kantengewichts. 
	 * @param o
	 * @param n0
	 * @param n1
	 * @param weight
	 */
	public WeightedEdge(Object o, Node n0, Node n1, double weight) {
		super(o, n0, n1);
		this.weight = weight;
	}

	/**
	 * Gibt das Kantengewicht zurck.
	 * @return
	 */
	public double getWeight() {
		return weight;
	}

	/**
	 * Setzt das Kantengewicht fest.
	 * @param weight
	 */
	public void setWeight(double weight) {
		this.weight = weight;
	}

	@Override
	public String toString() {
		return "Edge [" + object + ":" + weight +"]";
	}
	
	
	
	
	
	
	

}
